class Pendel {
  
 protected PVector ort_0,ort_1;
 protected PVector v,a;
 protected float federKonstante,ruheLaenge,masse; 
 
 private float g = 9.81;
 private float reibung = 0.002;
  
  Pendel(float p_x0, float p_y0, float p_ruheLaenge, float p_federKonstante, float p_masse) {
    ort_0 = new PVector(p_x0,p_y0);
    ort_1 = new PVector(p_x0,p_y0+p_ruheLaenge);
    ruheLaenge = p_ruheLaenge;
    federKonstante = p_federKonstante;
    masse = p_masse;
    v = new PVector(0,0);
    a = new PVector(0,0);
  }
  
  float getX0() { return ort_0.x; }
  float getY0() { return ort_0.y; }
  float getX1() { return ort_1.x; }
  float getY1() { return ort_1.y; }
  
  void setzeAnfangszustand(float p_x, float p_y) {
    ort_1 = new PVector(p_x,p_y);
    v  = new PVector(0,0);
    a  = new PVector(0,0);
  }
  
  void aktualisieren() {
    a = new PVector(ort_1.x-ort_0.x,ort_1.y-ort_0.y);
    a.normalize();
    float s = sqrt(sq(ort_1.x-ort_0.x)+sq(ort_1.y-ort_0.y))-ruheLaenge;
    
    a.mult(-s*federKonstante/masse);
    // addiere die Erdbeschleunigung zur Pendelbeschleunigung
    a.add(0,g);
    v.add(a.x*zeitIntervall,a.y*zeitIntervall);
    // Reibung vermindert die Geschwindigkeit in horizontaler und veritikaler Richtung
    v.mult(1-reibung);
    ort_1.add(v.x*zeitIntervall,v.y*zeitIntervall);
  }
  
  void display() {//zeichnet die Feder und die Masse (
    float ang = PI/2-atan2(ort_1.y-ort_0.y,ort_1.x-ort_0.x);
    float s = sqrt(sq(ort_1.x-ort_0.x)+sq(ort_1.y-ort_0.y));
    pushMatrix();
    translate(ort_0.x,ort_0.y);
    rotate(ang);
    noFill(); 
    stroke(0);
    beginShape();
    vertex(  0,0);
    vertex(  0,s*0.15);
    vertex(-40,s*0.20);
    vertex( 40,s*0.30);
    vertex(-40,s*0.40);
    vertex( 40,s*0.50);
    vertex(-40,s*0.60);
    vertex( 40,s*0.70);
    vertex(-40,s*0.80);
    vertex(  0,s*0.85);
    vertex(  0,s);
    endShape();
    fill(0);
    ellipse(0,s,40,40);
    popMatrix();
  }
}