//////////////////////////////////////////////////////////////////////////
//Federpendel auch horizontal ausgelenkt    aus Kapitel Simulation
////////////////////////////////////////////////////////////////////

float ruheLaenge=300;
float federKonstante=25.1*pow(1/1.5,15); // 15 mal '+' drücken, um auf 25.1 zu kommen...
float zeitIntervall=0.4;
float amplitude=100;
float masse=1;
Pendel pendel;

float ang;//Winkel der horizontalen Auslenkung

void setup() { 
  size(800, 800);
  pendel = new Pendel(width/2, 30, ruheLaenge, federKonstante, masse);
  //10 Grad (besser 5 Grad) sollten nicht überschritten werden. Sonst ist der Fehler zu groß
  ang = radians(10);
  pendel.setzeAnfangszustand(width/2+sin(ang)*ruheLaenge, 30+cos(ang)*ruheLaenge);
}

void draw() {
  background(255);
  pendel.aktualisieren();
  pendel.display();
}

void keyPressed() {
  if (key == '+') federKonstante *= 1.5;
  if (key == '-') federKonstante /= 1.5;
  if (key == 'i') zeitIntervall /= 1.5;
  if (key == 'I') zeitIntervall *= 1.5;
  println("Federkonstante: " + federKonstante); 
  println("Zeitintervall: " + zeitIntervall);
  pendel = new Pendel(width/2, 30, ruheLaenge, federKonstante,masse);
  pendel.setzeAnfangszustand(width/2+sin(ang)*ruheLaenge, 30+cos(ang)*ruheLaenge);
}